//
// System.Runtime.CompilerServices.RuntimeCompatibilityAttribute.cs
//
// Author: Zoltan Varga (vargaz@gmail.com)
//
// (C) Copyright, Ximian Inc.

//
// Copyright (C) 2005 Novell, Inc (http://www.novell.com)
//
// Permission is hereby granted, free of charge, to any person obtaining
// a copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to
// permit persons to whom the Software is furnished to do so, subject to
// the following conditions:
// 
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
// LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
// OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
// WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//

using System;

#if NET_2_0 || BOOTSTRAP_NET_2_0

namespace System.Runtime.CompilerServices {

	[Serializable]
	[AttributeUsage (AttributeTargets.Assembly, Inherited = false, AllowMultiple = false)]
	public sealed class RuntimeCompatibilityAttribute : Attribute
	{
#region Synch with object-internals.h
		bool wrap_non_exception_throws;
#endregion

		public RuntimeCompatibilityAttribute () {
		}

		public bool WrapNonExceptionThrows {
			get {
				return wrap_non_exception_throws;
			}
			set {
				wrap_non_exception_throws = value;
			}
		}
	}
}

#endif
